# $Id: iq.tcl,v 1.6 2002/11/02 20:42:03 alexey Exp $

namespace eval iq {}


proc iq::register_handler {type tag xmlns h} {
    variable handler
    variable supported_ns

    set handler($type,$tag,$xmlns) $h
    lappend supported_ns $xmlns
    set supported_ns [lrmdups $supported_ns]
}

proc iq::process_iq {from useid id type child} {
    variable handler

    jlib::wrapper:splitxml $child tag vars isempty chdata children

    set xmlns [jlib::wrapper:getattr $vars xmlns]

    if {[info exists handler($type,$tag,$xmlns)]} {
	set h $handler($type,$tag,$xmlns)
    } elseif {[info exists handler($type,,$xmlns)]} {
	set h $handler($type,,$xmlns)
    }

    if {[info exists h]} {
	set res [$h $from $child]

	if {$res != {}} {
	    switch -- [lindex $res 0] {
		result {
		    debugmsg iq "IQREPLY: SENDING: $from; $useid; $id; $child"
		    jlib::send_iq result [lindex $res 1] -to $from -id $id
		}
		error {
		    jlib::send_iq error \
			[jlib::wrapper:createtag error \
			     -vars [list code [lindex $res 1]] \
			     -chdata [lindex $res 2]] \
			-to $from -id $id
		}
	    }
	}
    } else {
	debugmsg iq "IQREPLY: SENDING: $from; $useid; $id; $child"
	# TODO
	jlib::send_iq error \
	    [jlib::wrapper:createtag error \
		 -vars {code 501} -chdata "Not Implemented"] \
	    -to $from -id $id
    }
}

proc client:iqreply {from useid id type child} {
    debugmsg iq "IQREPLY: $from; $useid; $id; $type; $child"

    iq::process_iq $from $useid $id $type $child
}


plugins::load [file join plugins iq]

