# $Id: draw_timestamp.tcl,v 1.2 2003/04/16 18:12:16 aleksey Exp $

custom::defvar options(timestamp_format) {[%R]} \
    [::msgcat::mc "Format of timestamp in chat message. \
Refer to Tcl documentation of 'clock' command for description of format.

Examles:
  \[%R\] -- \[20:37\]
  \[%T\] -- \[20:37:12\]
  \[%a %b %d %H:%M:%S %Z %Y\] -- \[Thu Jan 01 03:00:00 MSK 1970\]"] \
    -type string -group Chat

proc draw_timestamp {chatid from type body x} {
    variable options

    set chatw [chat::chat_win $chatid]

    set seconds [clock seconds]

    foreach xelem $x {
	jlib::wrapper:splitxml $xelem tag vars isempty chdata children
	
	if {[cequal [jlib::wrapper:getattr $vars xmlns] jabber:x:delay]} {
	    set seconds [clock scan [jlib::wrapper:getattr $vars stamp] -gmt 1]
	}
    }

    $chatw insert end \
	[clock format $seconds -format $options(timestamp_format)]
}
hook::add draw_message_hook [namespace current]::draw_timestamp 15
