# $Id: httpconn.tcl,v 1.1 2003/04/07 20:11:14 aleksey Exp $
# Author: Tomas Ebenlendr
# http://www.ucw.cz/~0rfelyus/twiki/view/Wishlist/TkabberHttpPlugin
# version 1.1

if {![info exists ::use_http_conn] || !$::use_http_conn} {
    return
}

package require http

namespace eval :: {
global HtWait SesKey OutData loginconf HtTimeout

set HtTimeout 15000

proc ht_set_def { which what } {
    global loginconf
    if ![catch {set loginconf($which)}] {
	if [string length [set loginconf($which)]] {return}
    }
    set loginconf($which) $what
}
ht_set_def resource "test-http"
ht_set_def server "jabber.cz"
ht_set_def pollmin 3000
ht_set_def pollmax 30000
ht_set_def url "http://connect.jabber.cz/"

custom::defvar loginconf(pollmin) "" \
	[::msgcat::mc "Minimum Poll Time."] \
	-group Login -type integer

custom::defvar loginconf(pollmax) "" \
	[::msgcat::mc "Maximum Poll Time."] \
	-group Login -type integer

custom::defvar loginconf(url) "" \
	[::msgcat::mc "Url to connect to."] \
	-group Login -type string

proc httpdebug {str} {
#    puts $str
}

#fixme
set toolbaricon(disconn) [Bitmap::get [pixmap roster unavailable.gif]]
set toolbaricon(conn)    [Bitmap::get [pixmap roster available-xa.gif]]
set toolbaricon(poll)    [Bitmap::get [pixmap roster available.gif]]

proc ht_set_bbox {} {
    global bbox toolbaricon
    $bbox add -image $toolbaricon(disconn) \
	-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 \
	-padx 1 -pady 1 -command {::Keep} \
	-helptext [::msgcat::mc "Do http poll"]
}
hook::add finload_hook ht_set_bbox 100
	    
proc show_http_request {isoff} {    
    global bbox
    global toolbaricon
    variable show_only_online

    if $isoff==3 {
	$bbox itemconfigure 4 -image $toolbaricon(poll)
    }
    if $isoff==2 {	
	$bbox itemconfigure 4 -image $toolbaricon(disconn)
    }
    if $isoff==1 {
	$bbox itemconfigure 4 -image $toolbaricon(poll)
    }
    if $isoff==0 {
	$bbox itemconfigure 4 -image $toolbaricon(conn)
    }
}

hook::add http_hook show_http_request 10

proc show_login_dialog {} {
    global loginconf
    global ltmp
    #global tmpusername tmppassword tmpresource tmpserver tmpport tmppriority
    #global tmpusessl tmpsslport tmpuseproxy tmphttpproxy tmphttpproxyport

    if {[winfo exists .login]} {
	focus -force .login
	return
    }

    array set ltmp [array get loginconf]

    Dialog .login -title [::msgcat::mc "Login"] \
	-separator 1 -anchor e -default 0 -cancel 1

    set l [.login getframe]
    
    label $l.lusername -text [::msgcat::mc "Username:"]
    ecursor_entry [entry $l.username -textvariable ltmp(user)]
    label $l.lserver -text [::msgcat::mc "Server:"]
    ecursor_entry [entry $l.server -textvariable ltmp(server)]
    label $l.lport -text [::msgcat::mc "Url:"]
    ecursor_entry [entry $l.port -textvariable ltmp(url)]
    label $l.lpassword -text [::msgcat::mc "Password:"]
    ecursor_entry [entry $l.password -show * -textvariable ltmp(password)]
    checkbutton $l.usedigest -text [::msgcat::mc "Use hashed password"] \
	-variable ltmp(usedigest)
    label $l.lresource -text [::msgcat::mc "Resource:"]
    ecursor_entry [entry $l.resource -textvariable ltmp(resource)]
    label $l.lpriority -text [::msgcat::mc "Priority:"]
    ecursor_entry [entry $l.priority -textvariable ltmp(priority)]
#    checkbutton $l.usealtserver -text [::msgcat::mc "Connect via alternate server"] \
#	-variable ltmp(usealtserver)
#    label $l.laltserver -text [::msgcat::mc "Server:"]
#    ecursor_entry [entry $l.altserver -textvariable ltmp(altserver)]

    grid $l.lusername -row 0 -column 0 -sticky e
    grid $l.username  -row 0 -column 1 -sticky ew
    grid $l.lserver   -row 1 -column 0 -sticky e
    grid $l.server    -row 1 -column 1 -sticky ew
#    grid $l.usealtserver -row 4 -column 1 -sticky w -columnspan 3
#    grid $l.laltserver -row 5 -column 0 -sticky e
#    grid $l.altserver -row 5 -column 1 -sticky ew
    grid $l.lpassword -row 2 -column 0 -sticky e
    grid $l.password  -row 2 -column 1 -sticky ew
    grid $l.lresource -row 3 -column 0 -sticky e
    grid $l.resource  -row 3 -column 1 -sticky ew
    grid $l.usedigest -row 2 -column 3 -sticky e
    grid $l.lport     -row 1 -column 2 -sticky e
    grid $l.port      -row 1 -column 3 -sticky ew
    grid $l.lpriority -row 3 -column 2 -sticky e
    grid $l.priority  -row 3 -column 3 -sticky ew

if 0 {
    if {$loginconf(use_tls)} {
	checkbutton $l.usessl -text [::msgcat::mc "Use SSL"] \
	    -variable ltmp(usessl)
	label $l.lsslport -text [::msgcat::mc "SSL Port:"]
	entry $l.sslport -textvariable ltmp(sslport)

	grid $l.usessl   -row 6 -column 1 -sticky w
	grid $l.lsslport -row 6 -column 2 -sticky e
	grid $l.sslport  -row 6 -column 3 -sticky ew

    }
}
    checkbutton $l.useproxy -text [::msgcat::mc "Use Proxy"] \
	-variable ltmp(useproxy)
    grid $l.useproxy -row 7 -column 1 -sticky w

    label $l.lhttpproxy -text [::msgcat::mc "Proxy Server:"]
    entry $l.httpproxy -textvariable ltmp(httpproxy)
    label $l.lhttpproxyport -text [::msgcat::mc "Proxy Port:"]
    entry $l.httpproxyport -textvariable ltmp(httpproxyport)

    grid $l.lhttpproxy     -row 8 -column 0 -sticky e
    grid $l.httpproxy      -row 8 -column 1 -sticky ew
    grid $l.lhttpproxyport -row 8 -column 2 -sticky e
    grid $l.httpproxyport  -row 8 -column 3 -sticky ew

    label $l.lhttplogin -text [::msgcat::mc "Proxy Login:"]
    entry $l.httplogin -textvariable ltmp(httplogin)
    label $l.lhttppassword -text [::msgcat::mc "Proxy Password:"]
    entry $l.httppassword -show * -textvariable ltmp(httppassword)

    grid $l.lhttplogin    -row 9 -column 0 -sticky e
    grid $l.httplogin     -row 9 -column 1 -sticky ew
    grid $l.lhttppassword -row 9 -column 2 -sticky e
    grid $l.httppassword  -row 9 -column 3 -sticky ew



    grid columnconfigure $l 1 -weight 1
    grid columnconfigure $l 3 -weight 1


    set n 1
    while {[info exists ::loginconf$n]} {incr n}
    incr n -1

    if {$n} {
	menubutton $l.profiles -text [::msgcat::mc Profiles] -relief raised \
	    -menu $l.profiles.menu
	set m [menu $l.profiles.menu -tearoff 0]
	for {set i 1} {$i <= $n} {incr i} {
	    if {[info exists ::loginconf${i}(profile)]} {
		set lab [set ::loginconf${i}(profile)]
	    } else {
		set lab "[::msgcat::mc Profile] $i"
	    }
	    if {$i < 10} {
		$m add command -label $lab -accelerator "Ctrl-$i" \
		    -command [list eval array set ltmp \
				  \[array get loginconf$i\]]
		bind .login <Control-Key-$i> [list eval array set ltmp \
						  \[array get loginconf$i\]]
	    } else {
		$m add command -label $lab \
		    -command [list eval array set ltmp \
				  \[array get loginconf$i\]]
	    }
	}
	#array set ltmp [array get ::loginconf1]

	grid $l.profiles -row 0 -column 3 -sticky e

    }

    .login add -text [::msgcat::mc "Log in"] -command {
	array set loginconf [array get ltmp]
	destroy .login
	logout
	update
	login
    }
    .login add -text [::msgcat::mc "Cancel"] -command {destroy .login}

    .login draw $l.password
}


#initialization
set HtWait 2
set SesKey -1
set OutData ""

namespace eval jlib {
    variable lib
    set lib(sckstats) "off"
}

proc setHtWait {to} {
    global HtWait
    if $HtWait!=$to {hook::run http_hook $to}
    set HtWait $to
    if $to==2 {
	if {[info exists PollId]} {
	    after cancel $PollId
	}
    }
}

proc MyFinished {token} {
    global HtWait SesKey
    upvar #0 $token state
    #predpokladam ze nevznikne najdenou Location a Set-Cookie
    if {[set temp [::http::ncode $token]] != 200} {
	::LOG "error (jlib::MyFinished) Http returned $temp"
	setHtWait 2
	jlib::emergency_disconnect
    }
    
    foreach {name value} $state(meta) {
	if {[regexp -nocase ^set-cookie$ $name]} {
	    set start 0
	    set end [string first ";" $value]
	    if {$end < 1} {
		set end [string length $value]
	    }
	    if {[regexp -nocase ^ID= $value]} {
		set start 3
	    }
	    set SesKey [string range $value $start $end]
	}
    }
    set inmsg $state(body)
    ::http::cleanup $token

    if {[regexp :0$ $SesKey] || [regexp %3A0$ $SesKey]} {
	::LOG "error (jlib::MyFinished) Cookie Error"
	setHtWait 2
	jlib::emergency_disconnect
    }
    global PollInt PollMin PollMax
    if {[string length $inmsg] > 5 } {
	set PollInt [expr $PollInt * 9 / 10]
	if {$PollInt < $PollMin} {
	    set PollInt $PollMin
	}
    } else {
	set PollInt [expr $PollInt * 11 / 10]
	if {$PollInt > $PollMax} {
	    set PollInt $PollMax
	}
    }

    #httpdebug "indata:$inmsg"
    jlib::HtInMsg $inmsg

    if ($HtWait>1) {
	setHtWait 2
    } else {
	setHtWait 0
    }
}


proc Keep {} {
    global HtWait
    if $HtWait==0 {
	Poll " "
    }
}

proc Poll {what} {
    global SesKey Url GlobTok HtWait OutData PollInt PollId Proxy HtTimeout
    namespace eval jlib {
	variable lib
    }

    set OutData "$OutData$what"
    if $HtWait!=0 {
	httpdebug "Waiting for godot!"
	return
    }
    set query "$SesKey,$OutData"
    httpdebug "outdata:$query"
    setHtWait 1
    if $Proxy(use) {
	::http::geturl $Url -query "$SesKey,$OutData" -command MyFinished -headers $Proxy(auth) -timeout $HtTimeout
    } else {
	::http::geturl $Url -query "$SesKey,$OutData" -command MyFinished -timeout $HtTimeout
	#MyFinished [::http::geturl $Url -query $query]
    }
    set OutData ""

    if {[info exists PollId]} {
	after cancel $PollId
    }
    httpdebug "Poll:$PollInt"
    set PollId [after $PollInt Keep]
}


proc jlib::HtInMsg {body} {
    #namespace eval jlib {
	variable lib

	if {$lib(sckstats) == "off"} {return}

	::LOG_INPUT $body
	if {[string length $body] > 2} {
#	    httpdebug [string length $body]
	    httpdebug "indata:$body"
	    wrapper:parser $lib(wrap) parse $body
	}
    #}
}


proc jlib::outmsg {msg} {
    set msg [encoding convertto utf-8 $msg]
    Poll $msg
}

proc jlib::disconnect {} {
    #namespace eval jlib {
	variable lib
	if {$lib(sckstats) == "off"} {
	   return
	}
    #}
    jlib::outmsg "</stream:stream>"
    hook::run http_hook 2
    clear_iqs
    clear_vars
    setHtWait 3
}

proc jlib::connect {tmp1 server} {
    global SesKey OutData PollInt PollMin
    set SesKey 0
    set PollInt $PollMin

    #namespace eval jlib {
	variable lib
	set lib(sck) -1
	set lib(sckstats) "on"
	set lib(mechanisms) {}
	set lib(server) -1
	set version ""

    setHtWait 0

	jlib::outmsg [cconcat \
		"<stream:stream"\
		" to='[wrapper:xmlcrypt $server]'"\
		" xmlns='jabber:client'" \
		" xmlns:stream='" [wrapper:xmlcrypt {http://etherx.jabber.org/streams}] "'"\
		"$version>"]
    #}
    return 0
}

#---------------------------------------------------------------------
proc login {} {
    global loginconf
    global gr_nick gr_server gra_server
    global auth_result

    global Url PollMin PollMax PollInt ProxyAuth Proxy
    set Server $loginconf(server)
    set Url $loginconf(url)
    set PollMin $loginconf(pollmin)
    set PollMax $loginconf(pollmax)
    set Pollint $PollMin

    set gr_nick $loginconf(user)
    set gr_server conference.$loginconf(server)
    set gra_server conference.$loginconf(server)

    if $loginconf(useproxy) {
	set Proxy(use)	    1
	::http::config -proxyhost $loginconf(httpproxy) -proxyport $loginconf(httpproxyport)

	if {$loginconf(httplogin) != ""} {
	    set auth [base64::encode \
	                      [encoding convertto "$loginconf(httplogin):$loginconf(httppassword)"]]
	    set Proxy(auth) [list "Proxy-Authorization" "Basic $auth"]
	} else {
	    set Proxy(auth) {}
	}
					  
	set Proxy(login)    $loginconf(httplogin)
	set Proxy(pass)     $loginconf(password)
    } else {
	set Proxy(use)	    0
	set Proxy(auth)     {}
    }

    jlib::connect "" $Server
    jlib::wait_for_stream

    if {$loginconf(usedigest)} {
	set authtype digest
    } else {
	set authtype plain
    }

    jlib::send_auth $loginconf(user) $loginconf(password) $loginconf(resource) \
	recv_auth_result $authtype
    vwait auth_result

    if {$auth_result == "OK"} {
	connected
	#jlib::send_presence -stat Online -pri $loginconf(priority) \
	#   -xlist [get_our_presence_xlist]
	jlib::roster_get -command client:roster_cmd
    }
}

}
